/* My tstring class

   Created by Joe Plante (c) 2010

   Feel free to use this in your own projects. If you are doing school work, please ask your
   instructors permission before using it. Most of this is inherited from basic_string and
   reliant on Win32 data types.

   Also, you would do me a huge favor if you could credit me for creating this class if you
   have some sort of credit roll.

Sources: http://msdn.microsoft.com/en-us/library/90ed6715%28v=VS.80%29.aspx

   TODO maybe later: rig append and operator+ to handle non-TCHAR datatypes

   The latest version of tstring is usually posted at princessblade.net. 

   MultiByteToWideChar will make this messy CP_UTF8
*/
#ifndef JOE_CUSTOM_TSTRING
#define JOE_CUSTOM_TSTRING

#include <windows.h>
#include <string>
 using std::string;
 using std::wstring;
 using std::basic_string;
#include <iostream>
 using std::cout;
 using std::cin;
 using std::wcout;
 using std::wcin;
#include <algorithm>
 using std::copy;
#include <string.h>
#include <wchar.h>
#include <Winnls.h>

#include <TCHAR.h>

//typedef basic_string<TCHAR> tstring; // So that I have an STL string that's set to the program settings

#ifdef _UNICODE
   #define tcout wcout
   #define tcin  wcin
#else
   #define tcout cout
   #define tcin  cin
#endif

class tstring : public basic_string<TCHAR>
{
public:

   // added constructors to help with replacing implementations that were just typedef basic_string<TCHAR> tstring;
   tstring(){};
   tstring(const tstring &in) { assign(in); };
//   tstring(tstring &in) { assign(in); };
   tstring(string &in)  { assign(in); };
   tstring(wstring &in) { assign(in); };
   tstring(char *in)    { assign(in); };
   tstring(wchar_t *in) { assign(in); };

   // assignment operators for the various string types. 
   tstring &assign(string &_str);
   tstring &assign(wstring &_wstr);
   tstring &assign(tstring &_tstr);
   tstring &assign(wchar_t *wc_str);
   tstring &assign(char    *c_str);

   // Eats an UTF c-style string. This is a special case compared to an ANSI string
   tstring &assignUTF8(char *c_str);
   tstring &assignUTF8Compostie(char *c_str);

   // added for STL compatibility
   tstring &assign(const tstring &_tstr);

   // operator=, which basically is the same as the .assign() function
   tstring &operator=(const tstring &rhs);
   tstring &operator=(tstring &rhs);

   tstring &operator=(string &rhs);
   tstring &operator=(wstring &rhs);
   tstring &operator=(char *rhs);
   tstring &operator=(wchar_t *rhs);

   // append recreated. I mostly want it to work on TCHAR and tstrings for now. 
   // I may add c string and wide strings later
   tstring &append(const tstring &_tstr);
   tstring &append(const TCHAR *tc);

   // operator +=, which makes operator + easier
   tstring &operator+=(const tstring &rhs);
   tstring &operator+=(const TCHAR *rhs);

   // operator+, adds two tstrings together
   tstring operator+(const tstring &rhs);
   tstring operator+(const TCHAR   *rhs);

   // operator== to detect equivalency
   bool operator==(const TCHAR *rhs);
   bool operator==(const tstring &rhs);
   
   // operator!= to detect non-equiv.
   bool operator!=(const TCHAR *rhs);
   bool operator!=(const tstring &rhs);

   // fill the output with the versions appropiate to what you are requesting. maxlen is the maxiumum amount of characters to copy.
   //
   // mbc_str is multibyte C string / wc_str is wide character string
   void mbc_str(char *output, size_t maxlen);
   void wc_str (wchar_t *output, size_t maxlen);

   // multibyte c++ string. 
   void mbcpp_str(string *out);

   // Wide c++ string
   void wcpp_str(wstring *out);
};
#endif
